// ECB/SIS Public License, version 1.0, document reference SIS/2001/116
//
// Copyright (C) 2006 European Central Bank. All rights reserved.
//
// Redistribution and use in source and binary forms,
// with or without modification, are permitted
// provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
// Redistributions in binary form must reproduce the above copyright notice,
// this list of conditions and the following disclaimer in the documentation
// and/or other materials provided with the distribution.
// Neither the name of the European Central Bank
// nor the names of its contributors may be used to endorse or promote products
// derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
// TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
// PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
// HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class DOMGetRate {

    /**
     * @param args
     */
    public static void main(final String[] args) {
        if (args.length != 3) {
            System.err.println("Usage: cmd filename currency date");
            System.exit(1);
        }

        final DocumentBuilderFactory factory = DocumentBuilderFactory
                .newInstance();
        factory.setNamespaceAware(true);
        DocumentBuilder parser;
        try {
            parser = factory.newDocumentBuilder();
            final Document data = parser.parse(args[0]);
            final Element root = data.getDocumentElement();
            final NodeList series = root.getElementsByTagName("Series");
            for (int i = 0; i < series.getLength(); i++) {
                if (series.item(i).getAttributes().getNamedItem("CURRENCY")
                        .getNodeValue().equals(args[1])) {
                    final Element selectedSeries = (Element) series.item(i);
                    final NodeList observations = selectedSeries.getElementsByTagName("Obs");
                    for (int j = 0; j < observations.getLength(); j++) {
                        if (observations.item(j).getAttributes().getNamedItem(
                                "TIME_PERIOD").getNodeValue().equals(args[2])) {
                            System.out.println("Exchange rate value for "
                                    + args[1]
                                    + " on "
                                    + args[2]
                                    + ": "
                                    + observations.item(j).getAttributes()
                                            .getNamedItem("OBS_VALUE")
                                            .getNodeValue());
                            System.exit(0);
                        }
                    }
                }
            }
        } catch (ParserConfigurationException e) {
            e.printStackTrace();
        } catch (SAXException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
